#!/usr/bin/perl -w

require News::NNTPClient;
use Date::Parse;

$c = new News::NNTPClient($ARGV[0]);
trace ( "Connecting to server: ".$ARGV[0]);

if (defined($ARGV[3])) 
  { $c->authinfo($ARGV[3],$ARGV[4]);
    trace ("User: ".$ARGV[3]." Passw: ***"); }

$c->group($ARGV[1]);
trace ("Selecting group:".$ARGV[1]);

open (GRP,">".$ARGV[1].".".sprintf("%04d-%02d-%02d-%02d-%02d",sub{1900+$_[5],$_[4]+1,$_[3],$_[2],$_[1],}->(localtime)).".txt") || die "Can't write to file";

$rotten = time - $ARGV[2] * 84000;

foreach (reverse $c->listgroup($ARGV[1])) { 
  $msgdate = chompnum($c->xhdr("Date",$_));
  $msgunixt = str2time($msgdate);
  if ( $msgunixt>$rotten ) {
    print GRP "Date: ",$msgdate; 
    print STDERR "."; 
    print GRP "From: ",chompnum($c->xhdr("From",$_));
    print GRP "Subject: ",chompnum($c->xhdr("Subject",$_));
    print GRP $c->body($_),"\n-------------\n";
  } else { print STDERR "X"; };
}

close GRP ;
$c->quit;

sub chompnum { return substr($_[0], index($_[0]," ")+1); };
sub trace { print STDERR $_[0]; };
