#!/usr/local/bin/perl

require News::NNTPClient;
use Date::Parse;

$block=30; $n=0 ;

trace ( "Connecting to server: ",$ARGV[0]);
$c = new News::NNTPClient($ARGV[0]);

if (defined($ARGV[3])) 
  { trace ("User: ",$ARGV[3]," Passw: ***"); 
    $c->authinfo($ARGV[3],$ARGV[4]); }

trace ("Selecting group:",$ARGV[1]);
($first, $last ) = ( $c->group($ARGV[1]) );
trace ("Newest:",chompnum($c->xhdr("Date",$last)));
trace ("Oldest:",chompnum($c->xhdr("Date",$first)));
$curr=$last;

open (GRP,">".$ARGV[1].".".sprintf("%04d-%02d-%02d-%02d-%02d",sub{1900+$_[5],$_[4]+1,$_[3],$_[2],$_[1],}->(localtime)).".txt") || die "Can't write to file";

$rotten = time - $ARGV[2] * 84000;

do {
 $n=0 ;
 @dates=$c->xhdr("Date",$curr-$block,$curr);
 @subjs=$c->xhdr("Subject",$curr-$block,$curr);
  %subjs = (0,0);
  foreach ( @subjs ) { $subjs{getnum($_)}=chompnum($_) ; };
 @froms=$c->xhdr("From",$curr-$block,$curr);
  %froms = (0,0);
  foreach ( @froms ) { $froms{getnum($_)}=chompnum($_) ; };

  foreach ( reverse @dates ) { 
  $msgdate = chompnum($_);
  $msgnum = getnum($_);
  $msgunixt = str2time($msgdate);
  if ( $msgunixt>$rotten ) {
    print GRP "Date: ",$msgdate; 
    print STDERR "."; 
    print GRP "From: ", $froms{$msgnum};
    print GRP "Subject: ", $subjs{$msgnum};
    print GRP $c->body($msgnum),"\n-------------\n";
    $n=$n+1;
  } else { print STDERR "X"; };
}
 $curr=$curr-$block-1;
 print STDERR "!";
} while ($n>0);

close GRP ;
$c->quit;

sub chompnum { return substr($_[0], index($_[0]," ")+1); };
sub getnum { return substr($_[0], 0, index($_[0]," ")); };
sub trace { print STDERR $_[0],$_[1],$_[2],"\n"; };